/* Example: menu system, using do...while, getchar and switch */

/* You've reached a point in the course where you know enough C
to start writing real programs. Here's a fairly realistic example:
a menu ordering system. It could be improved -- for instance there's 
no way to cancel an item. Also, when we get on to functions, the 
structure could be made more modular. Nevertheless, it works! */


#include <stdio.h>


#define BIG 2.50     /* price of Big Duck */
#define HAM 2.00     /* price of hamburger */
#define CHE 2.00     /* price of cheeseburger */
#define FRI 0.50     /* price of fries */
#define LAR 0.75     /* price of large fries */
#define SOF 0.50     /* price of soft drink */
#define APP 1.00     /* price of apple pie */
#define MIL 0.75     /* price of milk shake */


int main(void)
{
  char key;                /* key pressed */
  int items = 0;           /* number of food items */
  int done = 0;            /* order complete? */
  float total = 0.00;      /* total price */

  
  /* Output information: */
  
  puts("McDUCK'S ELECTRONIC MENU SYSTEM");
  puts("===============================\n");
  
  puts("Smile at customer; \"How may I help you?\"\n");

  puts("  [B]ig Duck     - press B (then Enter)");
  puts("  [H]amburger    - press H (then Enter)");
  puts("  [C]heeseburger - press C (then Enter)");
  puts("  [F]ries        - press F (then Enter)");
  puts("  [L]arge fries  - press L (then Enter)");
  puts("  [S]oft drink   - press S (then Enter)");
  puts("  [A]pple pie    - press A (then Enter)");
  puts("  [M]ilk shake   - press M (then Enter)\n");
  puts("Press [X] (then Enter) when order is complete\n");


  /* Handle key presses: */
    
  do {
       fflush(stdin);    /* flush keyboard buffer */
       key = getchar();  /* read key */
  
       switch (key)
       {
         case 'B': case 'b':
           printf("  Big Duck     $%4.2f\n", BIG);
           items++;
           total += BIG;
           break;

         case 'H': case 'h':
           printf("  Hamburger    $%4.2f\n", HAM);
           items++;
           total += HAM;
           break;

         case 'C': case 'c':
           printf("  Cheeseburger $%4.2f\n", CHE);
           items++;
           total += CHE;
           break;

         case 'F': case 'f':
           printf("  Fries        $%4.2f\n", FRI);
           items++;
           total += FRI;
           break;

         case 'L': case 'l':
           printf("  Large fries  $%4.2f\n", LAR);
           items++;
           total += LAR;
           break;

         case 'S': case 's':
           printf("  Soft drink   $%4.2f\n", SOF);
           items++;
           total += SOF;
           break;

         case 'A': case 'a':
           printf("  Apple pie    $%4.2f\n", APP);
           items++;
           total += APP;
           break;

         case 'M': case 'm':
           printf("  Milk shake   $%4.2f\n", MIL);
           items++;
           total += MIL;
           break;

         case 'X': case 'x':
           printf("\nOrder complete - ");
           printf("%i items - total $%4.2f\n", items, total);
           done = 1;
           break;

         default:
           puts("  Invalid key! Try again.");
           break;
       }
     } while (!done);
  
  
  /* Output information: */
  
  printf("\n\"Thank you! That'll be $%4.2f\"\n", total);
  puts("Take money, give change");
  puts("\"Thank you!\"\n");
  printf("\nFetch %i items\n", items);
  puts("\"Thanks for eating at McDuck's! Enjoy your meal!\"");
}
